using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using Microsoft.Xna.Framework.Content;

namespace WindowsGame2
{
    /// <summary>
    /// This is a game component that implements IUpdateable.
    /// </summary>
    public class FpsCalculator : Microsoft.Xna.Framework.GameComponent
    {
        public event FpsDelegate FpsUpdated;
        public delegate void FpsDelegate(FpsCalculator sender, int fps);

        double DeltaFPSTime = 0;
        int fps = 0;

        public FpsCalculator(Game game)
            : base(game)
        {
        }

        public override void Initialize()
        {
            base.Initialize();
        }

        public override void Update(GameTime gameTime)
        {
            double elapsed = gameTime.ElapsedGameTime.TotalSeconds;
            DeltaFPSTime += elapsed;
            if (DeltaFPSTime > 1)
            {
                if (FpsUpdated != null)
                    FpsUpdated(this, fps);
                DeltaFPSTime -= 1;
                fps = 0;
            }
            base.Update(gameTime);
        }

        public void Draw(GameTime gameTime)
        {
            fps++;
        }
    }
}