using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace WindowsGame2
{
    class FormManager
    {
        GraphicsDeviceManager graphics;
        FpsCalculator fps = null;

        Form xnaForm = null;
        FormEx winForm = null;
        bool IsFullScreen = false;

        public FormManager(Game game, GraphicsDeviceManager graphics)
        {
            this.graphics = graphics;

            // R|[lg̓o^
            fps = new FpsCalculator(game);
            game.Components.Add(fps);

            // EChE[hŋN
            winForm = new FormEx();
            xnaForm = Form.FromHandle(game.Window.Handle) as Form;
            xnaForm.FormBorderStyle = FormBorderStyle.None;
            xnaForm.Dock = DockStyle.Fill;
            xnaForm.TopLevel = false;
            xnaForm.Parent = winForm;
            xnaForm.Visible = true;

            winForm.Controls.Add(xnaForm);
            winForm.Show();

            fps.FpsUpdated += new FpsCalculator.FpsDelegate(fps_FpsUpdated);
        }

        /// <summary>
        /// Form̃^CgFPS\
        /// </summary>
        /// <param name="sender">FpsCalculator</param>
        /// <param name="fps">FPS</param>
        void fps_FpsUpdated(FpsCalculator sender, int fps)
        {
            winForm.Text = "FPS : " + fps;
        }

        /// <summary>
        /// `揈
        /// </summary>
        /// <param name="gameTime"></param>
        public void Draw(GameTime gameTime)
        {
            fps.Draw(gameTime);
        }

        /// <summary>
        /// WINDOW[h
        /// </summary>
        public void WindowMode()
        {
            if (!IsFullScreen) return;

            graphics.ToggleFullScreen();
            winForm.Parent = null;
            winForm.TopLevel = true;

            xnaForm.TopLevel = false;
            xnaForm.Parent = winForm;
            winForm.Controls.Add(xnaForm);

            IsFullScreen = false;
        }

        /// <summary>
        /// tXN[[h
        /// </summary>
        public void FullscreenMode()
        {
            if (IsFullScreen) return;

            winForm.Controls.Remove(xnaForm);
            xnaForm.Parent = null;
            xnaForm.TopLevel = true;

            winForm.TopLevel = false;
            winForm.Parent = xnaForm;

            graphics.ToggleFullScreen();
            IsFullScreen = true;
        }
    }
}
